''' Jeff Hoogland
 Starting Base for a World of Darkness CSS plugin
 Starting Date: 11/29/07
 This is our one config value
 Setting this to 0 will disable the game remembering your last character on map change/leave+rejoin
 Also set this to 0 if you are using a lan server'''
store_temp = 1

import es, popuplib, playerlib, random, gamethread, cPickle, sys, os.path, time, usermsg
import traceback as tb_module
Players = {}
Steamids = {}
Characters = {}
def load():
	es.server.cmd('echo Converting your server into a World of Darkness')
	es.ServerVar('WorldofDarkness').set('WOD 9.42')
	es.server.queuecmd('es_xmakepublic WorldofDarkness')
	global Characters
	str_path = es.getAddonPath('worldofdarkness') + '/Characters.db'
	if os.path.isfile(str_path):
		file_users = open(str_path)
		Characters = cPickle.load(file_users)
		file_users.close()
	if not es.exists('saycommand', 'wod'):
		es.regsaycmd('wod', 'worldofdarkness/wodchatcommand')
	if not es.exists('clientcommand', 'wod'):
		es.regclientcmd('wod', 'worldofdarkness/wodchatcommand')
	if not es.exists('command', 'heal'):
		es.regcmd('heal', 'worldofdarkness/healcommand')
	menucreate()
	es.server.cmd('echo Coversion finished... A shadow has fallen across your server')
def player_spawn(event_var):
	global Players
	global Characters
	if Players.has_key(event_var['userid']):
		if es.exists('userid', event_var['userid']):
			Userkey = Players[event_var['userid']]
			player = playerlib.getPlayer(event_var['userid'])
			player.set('health', 1124)
			Userkey['pen'] = 0
			Userkey['speed'] = 1.0
			Userkey['gravity'] = 1.0
			Userkey['maxhealth'] = 100
			es.server.queuecmd('est_setplayercolor %s 255 255 255 255 1'%event_var['userid'])
			gravity(event_var['userid'], 0)
			if Userkey.has_key('character'):
				global roundnumber
				charactername = Userkey['character']
				#currentname = es.getplayername(event_var['userid'])
				#if currentname != charactername:
					#es.server.cmd('est_name %s %s'%(event_var['userid'], charactername))
				template = Characters[charactername]['template']
				xp = Characters[charactername]['xp']
				es.tell(event_var['userid'], '#multi', '#greenCharacter Name:#lightgreen %s#green Template: #lightgreen %s #greenUnspent Xp: #lightgreen%f'%(charactername, template, xp))
				stamina = Characters[charactername]['Stamina']
				bonushealth = ((stamina-1)*(stamina-1))*2
				if bonushealth:
					health(event_var['userid'], bonushealth, 1)
					es.tell(event_var['userid'], '#lightgreen', 'Your stamina has granted you %i bonus health.'%bonushealth)
				bonusspeed = (Characters[charactername]['Strength'] + Characters[charactername]['Dexterity'])*.01
				speed(event_var['userid'], bonusspeed)
				if Characters[charactername].has_key('Fleet of Foot'):
					boost = Characters[charactername]['Fleet of Foot']*.03
					speed(event_var['userid'], boost)
				if Characters[charactername].has_key('Stealth'):
					if not Userkey.has_key('allow stealth'):
						Userkey['allow stealth'] = 0
					Userkey['stealth on'] = 0
				if Characters[charactername].has_key('Unseen Sense'):
					Userkey['us used'] = 0
				if Characters[charactername].has_key('Subterfuge'):
					dots = Characters[charactername]['Subterfuge']
					if dots == 1:
						chance = 5
					elif dots == 2:
						chance = 15
					elif dots == 3:
						chance = 30
					elif dots == 4:
						chance = 50
					elif dots == 5:
						chance = 80
					percent = random.randrange(99) + 1
					if chance >= percent:
						percent = random.randrange(3)
						path = 0
						if int(event_var['es_userteam']) == 2:
							if percent == 0:
								path = 'player/ct_urban'
							if percent == 1:
								path = 'player/ct_sas'
							if percent == 2:
								path = 'player/ct_gsg9'
							if percent == 3:
								path = 'player/ct_gign'
						elif int(event_var['es_userteam']) == 3:
							if percent == 0:
								path = 'player/t_phoenix'
							if percent == 1:
								path = 'player/t_leet'
							if percent == 2:
								path = 'player/t_guerilla'
							if percent == 3:
								path = 'player/t_arctic'
						if path != 0:
							es.server.cmd('est_setmodel %s %s'%(event_var['userid'], path))
							es.tell(event_var['userid'], '#lightgreen', 'Your subterfuge skill has allow you to look like the opposing team for this round!')
				if Characters[charactername].has_key('Athletics'):
					athlectics = Characters[charactername]['Athletics']
					Userkey['sprint status'] = 0
					lowergravity = -(((athlectics*athlectics)*2)*.01)
					gravity(event_var['userid'], lowergravity)
				if Characters[charactername].has_key('Resources'):
					resources = Characters[charactername]['Resources']
					bonuscash = (resources * resources) * 500
					cash(event_var['userid'], bonuscash)
					es.tell(event_var['userid'], '#multi', '#defaultYou have earn #green%i #defaultbonus cash for having #lightgreen%i #defaultDot(s) into resources.'%(bonuscash, resources))
				if Characters[charactername].has_key('Quick Healer'):
					regen(event_var['userid'], 1, 2, roundnumber)
				if template == 'Vampire':
					Userkey['torpor'] = 0
					Userkey['spawn location'] = es.getplayerlocation(event_var['userid'])
					if Characters[charactername].has_key('Nightmare'):
						fear_loop(event_var['userid'], roundnumber)
						dots = Characters[charactername]['Nightmare']
						if dots >= 2:
							Userkey['dread uses'] = 0
						if dots >= 3:
							Userkey['stare uses'] = 0
						if dots >= 4:
							Userkey['shatter uses'] = 0
						if dots >= 5:
							damage_loop(event_var['userid'], 1, 1, 480, roundnumber)
				elif template == 'Werewolf':
					Userkey['wolf form'] = 0
					Userkey['wolf used'] = 0
					regen(event_var['userid'], 1, 2, roundnumber)
					if Characters[charactername].has_key('Elemental'):
						dots = Characters[charactername]['Elemental']
						if dots >= 4:
							Userkey['whirlwind uses'] = 0
						if dots >= 5:
							Userkey['flood uses'] = 0
				elif template == 'Psion':
					if Characters[charactername].has_key('Psyic Healer'):
						regen(event_var['userid'], 3, 8, roundnumber)
					if Characters[charactername].has_key('Biokinesis'):
						Userkey['bio fleet'] = 0
						Userkey['bio quick'] = 0
						Userkey['bio str'] = 0
						Userkey['bio points'] = Characters[charactername]['Biokinesis']
						biomenu = popuplib.easymenu('biomenu', '_popup_choice', bioselect)
						biomenu.settitle('Biokinesis Enhancement Menu:')
						biolist = []
						if Userkey['bio fleet'] <= 2:
							biolist.append('Fleet of Foot')
						if Userkey['bio str'] <= 4:
							biolist.append('Hysterical Strength')
						if not Userkey['bio quick'] and Userkey['bio points'] >= 4:
							biolist.append('Quick Healer')
						for item in biolist:
							biomenu.addoption(item, item)
						if Userkey.has_key('bio points'):
							biomenu.send(event_var['userid'])
					if Characters[charactername].has_key('Mediumist'):
						if Characters[charactername]['Mediumist'] >= 2:
							Userkey['smite delay'] = 0
						if Characters[charactername]['Mediumist'] >= 3:
							Userkey['salt delay'] = 0
						if Characters[charactername]['Mediumist'] >= 4:
							Userkey['bane delay'] = 0
						if Characters[charactername]['Mediumist'] >= 5:
							Userkey['banish delay'] = 0
				elif template == 'Spirit':
					if not Characters[charactername].has_key('spirit type'):
						spiritmenu.send(event_var['userid'])
					es.server.cmd('est_setplayercolor %s 255 255 255 0 1'%event_var['userid'])
					es.setplayerprop(event_var['userid'], "CBasePlayer.m_lifeState", 1)
def player_falldamage(event_var):
	damage = int(float(event_var['damage']))
	dealdamage(event_var['userid'], event_var['userid'], damage, event_var['es_username'], 'world')
def player_hurt(event_var):
	damage = int(event_var['dmg_health'])
	if event_var['weapon'] == 'world':
		dealdamage(event_var['userid'], event_var['userid'], damage, event_var['es_username'], 'world')
	elif not int(event_var['attacker']):
		dealdamage(event_var['userid'], event_var['userid'], damage, event_var['es_username'], 'world')
	elif event_var['weapon'] != 'point_hurt':
		if es.exists('userid', event_var['userid']):
			if es.exists('userid', event_var['attacker']):
				player = playerlib.getPlayer(event_var['userid'])
				player.set('health', player.get('health') + damage)
				atemplate = 0
				vtemplate = 0
				adexterity = 0
				vdexterity = 0
				if Players.has_key(event_var['userid']):
					if Players[event_var['userid']].has_key('character'):
						vtemplate = Characters[Players[event_var['userid']]['character']]['template']
				if Players.has_key(event_var['attacker']):
					if Players[event_var['attacker']].has_key('character'):
						pen = Players[event_var['attacker']]['pen']
						charactername = Players[event_var['attacker']]['character']
						atemplate = Characters[charactername]['template']
						adexterity = Characters[charactername]['Dexterity'] - pen
						if Characters[charactername].has_key('Fighting Finesse'):
							bonusdamage = damage*(((adexterity - 1)*(adexterity - 1)*2)*.01)
							if bonusdamage >= 0:
								damage += bonusdamage
						else:
							strength = Characters[charactername]['Strength'] - pen
							if Players[event_var['attacker']].has_key('bio str'):
								strength += Players[event_var['attacker']]['bio str']
							bonusdamage = damage*(((strength - 1)*(strength - 1)*2)*.01)
							if bonusdamage >= 0:
								damage += bonusdamage
						if Characters[charactername].has_key('Occult'):
							if vtemplate != 'Mortal':
								dots = Characters[charactername]['Occult']
								if dots >= 1:
									damage = damage * 1.1
								elif dots >= 2 and vtemplate == 'Vampire':
									percent = random.randrange(6)
									if percent == 5:
										es.server.queuecmd('est_burn %s 5'%event_var['userid'])
										damage = damage * 2
								elif dots >= 3 and vtemplate == 'Werewolf':
									speed(event_var['userid'], -.02)
								elif dots >= 5 and vtemplate != 'Mortal':
									if random.randrange(6) == 0:
										stun(event_var['userid'], 5)
						if Characters[charactername].has_key('Larceny'):
							victim = playerlib.getPlayer(event_var['userid'])
							primary = victim.get('primary')
							if primary != '0':
								chance = (Characters[charactername]['Larceny'] - pen)*(Characters[charactername]['Larceny'] - pen)
								percent = random.randrange(99) + 1
								if chance >= percent:
									ammo = victim.get('ammo', 'primary')
									clip = victim.get('clip', 'primary')
									es.server.cmd('est_removeweapon %s 1;est_dropweapon %s 1;es_xgive %s weapon_%s'%(event_var['userid'], event_var['attacker'], event_var['attacker'], primary))
									attacker = playerlib.getPlayer(event_var['attacker'])
									attacker.set('ammo', ['primary', ammo])
									attacker.set('clip', ['primary', clip])
						if Characters[charactername].has_key('Stealth'):
							if Players[event_var['attacker']].has_key('stealth on'):
								on_off = Players[event_var['attacker']]['stealth on']
								gamethread.delayed(3, stealthdown, (event_var['attacker']))
								Players[event_var['attacker']]['allow stealth'] = Players[event_var['attacker']]['allow stealth'] + 1
								if on_off == 1:
									speed(event_var['attacker'], .2)
									damage = damage*(1 + (Characters[charactername]['Stealth']*.1))
									Players[event_var['attacker']]['stealth on'] = 0
									es.server.cmd('est_setplayercolor %s 255 255 255 255 1'%event_var['attacker'])
									es.tell(event_var['attacker'], '#lightgreen', 'You have come out of your stealth.')
						if Characters[charactername].has_key('Firearms'):
							firearms = Characters[charactername]['Firearms'] - pen
							bonusdamage = damage*((((firearms - 1)*(firearms - 1) + 1)*2)*.01)
							if bonusdamage >= 0:
								damage += bonusdamage
						if Characters[charactername].has_key('Elemental'):
							dots = Characters[charactername]['Elemental']
							if dots >= 1:
								percent = random.randrange(99) + 1
								if damage >= percent:
									es.server.cmd('est_fade %s 0 2 6 0 0 255 195'%event_var['userid'])
							if dots >= 2:
								percent = random.randrange(99) + 1
								if damage >= percent:
									gravity(event_var['userid'], .5)
							if dots >= 3:
								percent = random.randrange(99) + 1
								if damage >= percent:
									es.server.cmd('est_burn %s 6'%event_var['userid'])
				if Players.has_key(event_var['userid']):
					if Players[event_var['userid']].has_key('character'):
						pen = Players[event_var['userid']]['pen']
						charactername = Players[event_var['userid']]['character']
						vtemplate = Characters[charactername]['template']
						if Players[event_var['userid']].has_key('us used'):
							used = Players[event_var['userid']]['us used']
							if used == 0:
								if atemplate == 'Vampire' or atemplate == 'Werewolf':
									damage = 0
									Players[event_var['userid']]['us used'] = 1
									es.tell(event_var['userid'], '#lightgreen', 'Your unseen senses have helped you evade damage!')
						if damage != 0:
							if Characters[charactername].has_key('Danger Sense'):
								chance = random.randrange(19)
								if chance == 0:
									damage = 0
									es.tell(event_var['userid'], '#lightgreen', 'Your danger senses have helped you evade damage!')
						vdexterity = Characters[charactername]['Dexterity'] - adexterity - pen
						if damage != 0:
							chance = random.randrange(19) + 1
							if vdexterity >= chance:
								damage = 0
								es.tell(event_var['userid'], '#lightgreen', 'Your dexterity has allowed you to evade an attack.')
						if Characters[charactername].has_key('Occult'):
							if damage != 0:
								dots = Characters[charactername]['Occult']
								if dots >= 4:
									percent = random.randrange(5)
									if percent == 4:
										damage = 0
										es.tell(event_var['userid'], '#lightgreen', 'Your knowings of the occult has allowed you to evade a supernatural attack.')
						if Characters[charactername].has_key('Stealth'):
							if Players[event_var['userid']].has_key('stealth on'):
								on_off = Players[event_var['userid']]['stealth on']
								gamethread.delayed(3, stealthdown, (event_var['userid']))
								Players[event_var['userid']]['allow stealth'] = Players[event_var['userid']]['allow stealth'] + 1
								if on_off == 1:
									speed(event_var['userid'], .2)
									Players[event_var['userid']]['stealth on'] = 0
									es.server.cmd('est_setplayercolor %s 255 255 255 255 1'%event_var['userid'])
									es.tell(event_var['userid'], '#lightgreen', 'You have come out of your stealth.')
				dealdamage(event_var['userid'], event_var['attacker'], damage, event_var['es_username'], event_var['es_attackername'])
def player_death(event_var):
	global Players
	global Characters
	global list_soundsToStop
	for soundName in list_soundsToStop:
		es.stopsound(event_var['userid'], soundName)
	#es.msg('%s has died'%event_var['es_username'])
	if Players[event_var['userid']].has_key('character'):
		charactername = Players[event_var['userid']]['character']
		template = Characters[charactername]['template']
		if template == 'Vampire':
			gamethread.cancelDelayed('untorpor%s'%event_var['userid'])
		elif template == 'Werewolf':
			if Players[event_var['userid']].has_key('wolf form'):
				form = Players[event_var['userid']]['wolf form']
				if form == 1:
					gamethread.cancelDelayed('unwolf%s'%(event_var['userid']))
def player_team(event_var):
	global Players
	global Characters
	if Players.has_key(event_var['userid']):
		if es.exists('userid', event_var['userid']):
			Userkey = Players[event_var['userid']]
			if Userkey.has_key('character'):
				charactername = Userkey['character']
				template = Characters[charactername]['template']
				if template == 'Spirit' and int(event_var['team']) != 1:
					if int(event_var['team']):
						es.server.queuecmd('est_team %s 0'%event_var['userid'])
def xpbuild(userid, choice, popupid):
	global Players
	global Characters
	if Players[str(userid)].has_key('character'):
		charactername = Players[str(userid)]['character']
		template = Characters[charactername]['template']
		xp = Characters[charactername]['xp']
		if choice == 1:
			merritmenu = popuplib.easymenu('merritmenu', '_popup_choice', merritselect)
			merritmenu.settitle('Select a Merrit to purchase with Xp:')
			merrits = []
			if Characters[charactername].has_key('Resources'):
				if Characters[charactername]['Resources'] <= 4:
					merrits.append('Resources')
			else:
				merrits.append('Resources')
			if Characters[charactername].has_key('Fleet of Foot'):
				if Characters[charactername]['Fleet of Foot'] <= 2:
					merrits.append('Fleet of Foot')
			else:
				merrits.append('Fleet of Foot')
			dexterity = Characters[charactername]['Dexterity']
			if dexterity >= 3:
				if not Characters[charactername].has_key('Fighting Finesse'):
					merrits.append('Fighting Finesse')
			stamina = Characters[charactername]['Stamina']
			if stamina >= 4:
				if not Characters[charactername].has_key('Quick Healer'):
					merrits.append('Quick Healer')
			if not Characters[charactername].has_key('Danger Sense'):
				merrits.append('Danger Sense')
			if template == 'Mortal':
				if not Characters[charactername].has_key('Unseen Sense'):
					merrits.append('Unseen Sense')
			elif template == 'Psion':
				if Characters[charactername].has_key('Biokinesis'):
					if Characters[charactername]['Biokinesis'] <= 4:
						merrits.append('Biokinesis')
				else:
					merrits.append('Biokinesis')
				if Characters[charactername].has_key('Mediumist'):
					if Characters[charactername]['Mediumist'] <= 4:
						merrits.append('Mediumist')
				else:
					merrits.append('Mediumist')
				if not Characters[charactername].has_key('Psyic Healer'):
					merrits.append('Psyic Healer')
			for merrit in merrits:
				merritmenu.addoption(merrit, merrit)
			merritmenu.send(userid)
		elif choice == 2:
			skillsmenu = popuplib.easymenu('skillsmenu', '_popup_choice', skillselect)
			skillsmenu.settitle('Select a Skill to purchase with Xp:')
			skills = []
			global skillslist
			for skill in skillslist:
				if Characters[charactername].has_key(skill):
					if Characters[charactername][skill] <= 4:
						skills.append(skill)
				else:
					skills.append(skill)
			for skill in skills:
				skillsmenu.addoption(skill, skill)
			skillsmenu.send(userid)
		elif choice == 3:
			powermenu = popuplib.easymenu('powermenu', '_popup_choice', powerselect)
			powermenu.settitle('Select a Power to purchase with Xp:')
			power = []
			template = Characters[charactername]['template']
			if template == 'Vampire':
				global discplineslist
				for discipline in discplineslist:
					if Characters[charactername].has_key(discipline):
						if Characters[charactername][discipline] <= 4:
							power.append(discipline)
					else:
						power.append(discipline)
			elif template == 'Werewolf':
				global giftslist
				for gift in giftslist:
					if Characters[charactername].has_key(gift):
						if Characters[charactername][gift] <= 4:
							power.append(gift)
					else:
						power.append(gift)
			elif template == 'Spirit':
				for h in hauntings:
					if Characters[charactername].has_key(h):
						if Characters[charactername][h] <= 4:
							power.append(h)
					else:
						power.append(h)
			else:
				es.tell(userid, '#lightgreen', 'There are no supernatural powers for you!')
			if template == 'Vampire' or template == 'Werewolf' or template == 'Spirit':
				for p in power:
					powermenu.addoption(p, p)
				powermenu.send(userid)
		elif choice == 4:
			if Characters[charactername]['template'] == 'Mortal':
				templatemenu = popuplib.easymenu('templatemenu', '_popup_choice', templateselect)
				templatemenu.settitle('Select a Template to purchase with Xp:')
				templates = ['Vampire', 'Werewolf', 'Psion', 'Spirit']
				for template in templates:
					templatemenu.addoption(template, template)
				templatemenu.send(userid)
			else:
				es.tell(userid, '#lightgreen', 'You already have a supernatural template!')
		elif choice == 5:
			attributesmenu = popuplib.easymenu('attributemenu', '_popup_choice', attributeselect)
			attributesmenu.settitle('Select an Attribute to purchase with Xp:')
			attributes = []
			global attributeslist
			for at in attributeslist:
				if Characters[charactername][at] <= 4:
					attributes.append(at)
			for at in attributes:
				attributesmenu.addoption(at, at)
			attributesmenu.send(userid)
def powerselect(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	template = Characters[charactername]['template']
	xp = Characters[charactername]['xp']
	if Characters[charactername].has_key(choice):
		dots = Characters[charactername][choice]
	else:
		dots = 0
	xpneeded = (dots + 1) * 5
	if xp >= xpneeded:
		choicemenu = popuplib.easymenu('choicemenu', '_popup_choice', pchoiceselect)
		Players[str(userid)]['Pending Power'] = choice
		newskill = dots + 1
		choicemenu.settitle('You currently have %f Xp. It will cost %i Xp to earn dot %i into %s'%(xp, xpneeded, newskill, choice))
		choicemenu.addoption(xpneeded, 'Spend the Xp')
		choicemenu.addoption('nope!', 'Nevermind')
		choicemenu.send(userid)
	else:
		es.tell(userid, '#lightgreen', 'You need %i Xp to advance your %s!'%(xpneeded, choice))
def pchoiceselect(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	template = Characters[charactername]['template']
	xp = Characters[charactername]['xp']
	if choice != '!nope':
		xp -= choice
		Characters[charactername]['xp'] = xp
		power = Players[str(userid)]['Pending Power']
		if Characters[charactername].has_key(power):
			increasedpower = Characters[charactername][power] + 1
		else:
			increasedpower = 1
		Characters[charactername][power] = increasedpower
		es.tell(userid, '#multi', '#default%s Dot #lightgreen %i#default Purchased.'%(power, increasedpower))
def templateselect(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	template = Characters[charactername]['template']
	xp = Characters[charactername]['xp']
	Players[str(userid)]['Pending Template'] = choice
	if choice == 'Vampire' or choice == 'Werewolf':
		xpneeded = 15
	elif choice == 'Psion':
		xpneeded = 5
	elif choice == 'Spirit':
		xpneeded = 20
	if xp >= xpneeded:
		tempconfirm = popuplib.easymenu('tempconfirm', '_popup_choice', tempsel)
		tempconfirm.settitle('You currently have %f Xp. It will cost %i Xp to become a %s'%(xp, xpneeded, choice))
		tempconfirm.addoption(xpneeded, 'Spend the Xp')
		tempconfirm.addoption('nope!', 'Nevermind')
		tempconfirm.send(userid)
	else:
		es.tell(userid, '#lightgreen', 'You need %i Xp to to become a %s!'%(xpneeded, choice))
def tempsel(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	template = Characters[charactername]['template']
	xp = Characters[charactername]['xp']
	if choice != '!nope':
		xp -= choice
		Characters[charactername]['xp'] = xp
		template = Players[str(userid)]['Pending Template']
		Characters[charactername]['template'] = template
		es.tell(userid, '#multi', '#defaultYou are now a #lightgreen %s#default.'%template)
def skillselect(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	template = Characters[charactername]['template']
	xp = Characters[charactername]['xp']
	if Characters[charactername].has_key(choice):
		skill_dots = Characters[charactername][choice]
	else:
		skill_dots = 0
	xpneeded = (skill_dots + 1) * 3
	if xp >= xpneeded:
		choicemenu = popuplib.easymenu('choicemenu', '_popup_choice', schoiceselect)
		Players[str(userid)]['Pending Skill'] = choice
		newskill = skill_dots + 1
		choicemenu.settitle('You currently have %f Xp. It will cost %i Xp to earn dot %i into %s'%(xp, xpneeded, newskill, choice))
		choicemenu.addoption(xpneeded, 'Spend the Xp')
		choicemenu.addoption('nope!', 'Nevermind')
		choicemenu.send(userid)
	else:
		es.tell(userid, '#lightgreen', 'You need %i Xp to advance your %s!'%(xpneeded, choice))
def schoiceselect(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	template = Characters[charactername]['template']
	xp = Characters[charactername]['xp']
	if choice != 'nope!':
		xp -= choice
		Characters[charactername]['xp'] = xp
		skill = Players[str(userid)]['Pending Skill']
		if Characters[charactername].has_key(skill):
			increasedskill = Characters[charactername][skill] + 1
		else:
			increasedskill = 1
		Characters[charactername][skill] = increasedskill
		es.tell(userid, '#multi', '#default%s Dot #lightgreen %i#default Purchased.'%(skill,increasedskill))
def attributeselect(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	template = Characters[charactername]['template']
	xp = Characters[charactername]['xp']
	stat_dots = Characters[charactername][choice]
	xpneeded = (stat_dots + 1) * 5
	if xp >= xpneeded:
		choicemenu = popuplib.easymenu('choicemenu', '_popup_choice', achoiceselect)
		Players[str(userid)]['Pending Stat'] = choice
		newstat = stat_dots + 1
		choicemenu.settitle('You currently have %f Xp. It will cost %i Xp to earn dot %i into %s'%(xp, xpneeded, newstat, choice))
		choicemenu.addoption(xpneeded, 'Spend the Xp')
		choicemenu.addoption('nope!', 'Nevermind')
		choicemenu.send(userid)
	else:
		es.tell(userid, '#lightgreen', 'You need %i Xp to advance your %s!'%(xpneeded, choice))
def achoiceselect(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	template = Characters[charactername]['template']
	xp = Characters[charactername]['xp']
	if choice != 'nope!':
		xp -= choice
		Characters[charactername]['xp'] = xp
		stat = Players[str(userid)]['Pending Stat']
		increasedstat = Characters[charactername][stat] + 1
		Characters[charactername][stat] = increasedstat
		es.tell(userid, '#multi', '#default%s Dot #lightgreen %i#default Purchased.'%(stat,increasedstat))
def merritselect(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	template = Characters[charactername]['template']
	xp = Characters[charactername]['xp']
	Players[str(userid)]['Pending Merrit'] = choice
	if choice == 'Resources' or choice == 'Fleet of Foot' or choice == 'Biokinesis' or choice == 'Mediumist':
		if Characters[charactername].has_key(choice):
			dots = Characters[charactername][choice]
		else:
			dots = 0
		xpneeded = (dots + 1) * 2
		mtype = 'multi'
	elif choice == 'Fighting Finesse' or choice == 'Unseen Sense':
		xpneeded = 6
		mtype = 'single'
	elif choice == 'Danger Sense':
		xpneeded = 4
		mtype = 'single'
	elif choice == 'Quick Healer':
		xpneeded = 8
		mtype = 'single'
	elif choice == 'Psyic Healer':
		xpneeded = 10
		mtype = 'single'
	if mtype == 'multi':
		if xp >= xpneeded:
			multimenu = popuplib.easymenu('multimenu', '_popup_choice', multiselect)
			newdots = dots + 1
			multimenu.settitle('You currently have %f Xp. It will cost %i Xp to earn dot %i into %s'%(xp, xpneeded, newdots, choice))
			multimenu.addoption(xpneeded, 'Spend the Xp')
			multimenu.addoption('nope!', 'Nevermind')
			multimenu.send(userid)
		else:
			es.tell(userid, '#lightgreen', 'You need %i Xp to advance your %s!'%(xpneeded, choice))
	elif mtype == 'single':
		if xp >= xpneeded:
			singlemenu = popuplib.easymenu('singlemenu', '_popup_choice', singleselect)
			singlemenu.settitle('You currently have %f Xp. It will cost %i Xp to earn the %s merrit'%(xp, xpneeded, choice))
			singlemenu.addoption(xpneeded, 'Spend the Xp')
			singlemenu.addoption('nope!', 'Nevermind')
			singlemenu.send(userid)
		else:
			es.tell(userid, '#lightgreen', 'You need %i Xp to advance your %s!'%(xpneeded, choice))
def singleselect(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	template = Characters[charactername]['template']
	xp = Characters[charactername]['xp']
	if choice != 'nope!':
		merrit = Players[str(userid)]['Pending Merrit']
		xp -= choice
		Characters[charactername]['xp'] = xp
		es.tell(userid, '#multi', '#green%s #default Purchased.'%merrit)
		Characters[charactername][merrit] = 'single'
def multiselect(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	template = Characters[charactername]['template']
	xp = Characters[charactername]['xp']
	if choice != 'nope!':
		merrit = Players[str(userid)]['Pending Merrit']
		xp -= choice
		Characters[charactername]['xp'] = xp
		if Characters[charactername].has_key(merrit):
			dots = Characters[charactername][merrit] + 1
		else:
			dots = 1
		es.tell(userid, '#multi', '#default%s Dot #lightgreen %i#default Purchased.'%(merrit, dots))
		Characters[charactername][merrit] = dots
def es_map_start(event_var):
	global Steamids
	for key in Steamids:
		pdic = Steamids[key]
		pdic['count'] += 1
		if pdic['count'] >= 3:
			del pdic
def player_activate(event_var):
	if es.exists('userid', event_var['userid']):
		global Players
		Players[event_var['userid']] = {}
		welcomemenu.send(event_var['userid'])
	if store_temp:
		global Steamids
		if not Steamids.has_key(event_var['es_steamid']):
			Steamids[event_var['es_steamid']] = {}
			Steamids[event_var['es_steamid']]['count'] = 0
		else:
			if Steamids[event_var['es_steamid']].has_key('character'):
				Players[event_var['userid']]['character'] = Steamids[event_var['es_steamid']]['character']
				Steamids[event_var['es_steamid']]['count'] -= 1
def player_disconnect(event_var):
	global Players
	if Players.has_key(event_var):
		del Players[event_var['userid']]
def round_start(event_var):
	global Players
	global Characters
	es.msg('#multi', '#green { #lightgreenWorld #defaultof #lightgreenDarkness #green} #defaultis running. Use #lightgreenWoD Help #defaultin chat for a command list.')
	for userid in playerlib.getUseridList('#all'):
		if Players.has_key(str(userid)):
			if Players[str(userid)].has_key('character'):
				charactername = Players[str(userid)]['character']
				bonusteamhealth = (Characters[charactername]['Presence'] - 1)*(Characters[charactername]['Presence'] - 1)
				if bonusteamhealth:
					if int(es.getplayerteam(userid)) == 2:
						for int_userid in playerlib.getUseridList('#t'):
							if int_userid != userid:
								health(int_userid, bonusteamhealth, 1)
					elif int(es.getplayerteam(userid)) == 3:
						for int_userid in playerlib.getUseridList('#ct'):
							if int_userid != userid:
								health(int_userid, bonusteamhealth, 1)
				template = Characters[charactername]['template']
				if template == 'Spirit':
					es.server.cmd('est_team %s 0'%userid)
					if playerlib.getPlayer(userid).get('isdead'):
						es.server.cmd('est_spawn %s 1'%userid)
					Players[str(userid)]['speed'] = 1.0
					speed(userid, -.4)
					increase = 0
					if Characters[charactername].has_key('Playful'):
						dots = Characters[charactername]['Playful']
						if dots >= 1:
							Players[str(userid)]['tele delay'] = 0
						if dots >= 2:
							Players[str(userid)]['swap delay'] = 0
						if dots >= 3:
							drug_loop(userid, roundnumber)
						if dots >= 4:
							pull_loop(userid, roundnumber)
						if dots >= 5:
							increase = 240
					if Characters[charactername].has_key('spirit type'):
						type = Characters[charactername]['spirit type']
						if type == 'Healing':
							arearegen(userid, 5, 5, 240+increase, roundnumber)
						elif type == 'Hateful':
							spirit_loop(userid, 5, 5, 240+increase, roundnumber)
						elif type == 'Annoying':
							spiritmenu.send(userid)
							es.tell(userid, '#lightgreen', 'Due to player issues the Annoying Spirit has been removed please choose a new type to play as.')
def random_loop(userid, delay, radius, roundstarted):
	if roundstarted == roundnumber:
		if es.exists('userid', userid):
			es.ServerVar('player').set(0)
			es.server.cmd('est_near player #a %s %s "es_xdoblock worldofdarkness/random_run"'%(radius, userid))
			gamethread.delayed(delay, random_loop, (userid, delay, radius, roundstarted))
def random_run():
	randomview(str(es.ServerVar('player')))
def item_pickup(event_var):
	global Players
	global Characters
	if Players.has_key(event_var['userid']):
		if Players[event_var['userid']].has_key('character'):
			charactername = Players[event_var['userid']]['character']
			template = Characters[charactername]['template']
			if Players[event_var['userid']].has_key('wolf form'):
				wolf = Players[event_var['userid']]['wolf form']
				if wolf == 1:
					if event_var['item'] != 'knife':
						es.server.cmd('est_dropweapon %s weapon_%s'%(event_var['userid'], event_var['item']))
			elif template == 'Spirit':
				es.server.queuecmd('est_dropweapon %s weapon_%s'%(event_var['userid'], event_var['item']))
roundnumber = 0
def server(event_var):
	global roundnumber
	roundnumber = 1
def round_end(event_var):
	global Characters
	if event_var['winner'] == '2':
		if int(es.getplayercount(2)):
			for int_userid in playerlib.getUseridList('#t'):
				xp(int_userid, .5)
			for int_userid in playerlib.getUseridList('#ct'):
				xp(int_userid, .25)
	elif event_var['winner'] == '3':
		if int(es.getplayercount(3)):
			for int_userid in playerlib.getUseridList('#ct'):
				xp(int_userid, .5)
			for int_userid in playerlib.getUseridList('#t'):
				xp(int_userid, .25)
	for int_userid in playerlib.getUseridList('#all'):
		if Players.has_key(str(int_userid)):
			if Players[str(int_userid)].has_key('character'):
				if Characters[Players[str(int_userid)]['character']]['template'] == 'Spirit':
					xp(int_userid, .25)
	global roundnumber
	roundnumber += 1
	str_path = open(es.getAddonPath('worldofdarkness') + '/Characters.db', 'w')
	cPickle.dump(Characters, str_path)
	str_path.close()
def xp(int_userid, amount):
	global Players
	global Characters
	if Players.has_key(str(int_userid)):
		if Players[str(int_userid)].has_key('character'):
			character = Players[str(int_userid)]['character']
			xp = Characters[character]['xp'] + amount
			totalxp = Characters[character]['totalxp'] + amount
			if totalxp <= 200:
				Characters[character]['xp'] = xp
				Characters[character]['totalxp'] = totalxp
				es.tell(int_userid, '#multi', '#defaultYou now have #lightgreen%s #defaultunspent experience points.'%xp)
			else:
				es.tell(int_userid, '#multi', '#defaultYou have earned the maxium of allowed #lightgreenXp #defaultfor a single character!')
merritslist = ['Resources', 'Fighting Finesse', 'Quick Healer', 'Unseen Sense', 'Fleet of Foot', 'Danger Sense', 'Biokinesis', 'Psyic Healer', 'Mediumist']
skillslist = ['Firearms', 'Athletics', 'Stealth', 'Subterfuge', 'Larceny', 'Occult']
attributeslist = ['Strength', 'Dexterity', 'Stamina', 'Presence']
discplineslist = ['Nightmare']
giftslist = ['Elemental']
hauntings = ['Playful']
list_soundsToStop = ['ambient/nature/fire/fire_small1.wav', 'ambient/fire/fire_big_loop1.wav', 'ambient/fire/fire_med_loop1.wav', 'ambient/fire/fire_small_loop2.wav', 'ambient/fire/gascan_ignite1.wav'] 
def mainselect(userid, choice, popupid):
	global Characters
	global Players
	Userkey = Players[str(userid)]
	if choice == 1:
		es.tell(userid, '#multi', '#defaultHit your #greenEscape Key #defaultand then type the name you want in the open field.')
		es.escinputbox(10, userid, '-{ World of Darkness Character Creation }-', 'Enter a Name:', 'wod create')
	elif choice == 2:
		es.tell(userid, '#multi', '#defaultHit your #greenEscape Key #defaultand then type the name of the character you want to load in the box.')
		es.escinputbox(10, userid, '-{ World of Darkness Load Character }-', 'Enter Character Name:', 'wod load')
	elif choice == 3:
		statmenu(str(userid))
def wodchatcommand():
	global Players
	global Characters
	global Steamids
	global roundnumber
	userid = str(es.getcmduserid())
	steamid = es.getplayersteamid(userid)
	arg1 = es.getargv(1).lower()
	argcount = es.getargc()
	stringcount = 2
	commandstring = ''
	while stringcount <= argcount:
		addstring = es.getargv(stringcount)
		commandstring = '%s %s'%(commandstring, addstring)
		stringcount += 1
	if arg1 == 'msg':
		name = es.getplayername(userid)
		es.msg('#multi', '#greenAdmin %s: #lightgreen%s'%(name, commandstring))
	elif arg1 == 'menu':
		mainmenu.send(userid)
	elif arg1 == 'help':
		welcomemenu.send(userid)
	elif arg1 == 'info':
		infomenu.send(userid)
	elif arg1 == 'stats':
		if Players.has_key(userid):
			statmenu(userid)
	elif arg1 == 'xp':
		xpmenu.send(userid)
	elif arg1 == 'create':
		if not Characters.has_key(commandstring):
			Characters[commandstring] = {}
			Characters[commandstring]['template'] = 'Mortal'
			Characters[commandstring]['xp'] = 0.0
			Characters[commandstring]['totalxp'] = 0.0
			Characters[commandstring]['Strength'] = 1
			Characters[commandstring]['Dexterity'] = 1
			Characters[commandstring]['Stamina'] = 1
			Characters[commandstring]['Presence'] = 1
			Players[userid]['character'] = commandstring
			Steamids[steamid]['character'] = commandstring
			es.tell(userid, '#multi', '#defaultCharacter #lightgreen%s #defaultCreated. Press your #greenEscape Key #defaultand then enter the password you want in the open field.'%commandstring)
			es.escinputbox(10, userid, '-{ World of Darkness Character Creation }-', 'Enter a Password:', 'wod passwordset')
		else:
			es.tell(userid, '#multi', '#defaultCharacter: #green%s #defaultalready exists in the character data base! Please try a different name.'%commandstring)
			es.escinputbox(10, userid, '-{ World of Darkness Load Character }-', 'Enter Character Name:', 'wod load')
	elif arg1 == 'passwordset':
		if Players[userid].has_key('character'):
			character = Players[userid]['character']
			if not Characters[character].has_key('password'):
				Characters[character]['password'] = commandstring
				es.tell(userid, '#multi', '#defaultCharacter: #lightgreen%s #defaultPassword: #green%s#default. Use this information to load this character from now on.'%(character, commandstring))
			else:
				es.tell(userid, '#lightgreen', 'Your character already has a password stored.')
	elif arg1 == 'load':
		if Characters.has_key(commandstring):
			player = playerlib.getPlayer(userid)
			charactername = 0
			if Players[userid].has_key('character'):
				charactername = Players[userid]['character']
			dead = int(player.get('isdead'))
			if dead == 1 or charactername == 0:
				samename = 0
				for int_userid in playerlib.getUseridList('#all'):
					if Players[str(int_userid)].has_key('character'):
						checkname = Players[str(int_userid)]['character']
						if checkname == commandstring:
							samename = 1
				if samename == 0:
					Players[userid]['pending character'] = commandstring
					es.tell(userid, '#multi', '#defaultCharacter #lightgreen%s #defaultPending. Press your #greenEscape Key #defaultand then enter your password to finish loading.'%commandstring)
					es.escinputbox(10, userid, '-{ World of Darkness Load Character }-', 'Enter the Password:', 'wod passwordenter')
				else:
					es.tell(userid, '#lightgreen', 'Some one on the server already has this character loaded!')
			else:
				es.tell(userid, '#lightgreen', 'You may not load a character while alive.')
		else:
			es.tell(userid, '#multi', '#defaultCharacter: #green%s #default does not exists in the data base. Please check your typing in try again!'%commandstring)
			es.escinputbox(10, userid, '-{ World of Darkness Load Character }-', 'Enter the Password:', 'wod passwordenter')
	elif arg1 == 'passwordenter':
		if Players[userid].has_key('pending character'):
			if Players[userid].has_key('pending character'):
				pending = Players[userid]['pending character']
				if Characters[pending].has_key('password'):
					password = Characters[pending]['password']
				else:
					password = commandstring
					es.tell(userid, '#multi', '#defaultThis character does not currently have a password set use #greenWoD PasswordSet #lightgreen<Password> #defaultin chat to set one.')
				if commandstring == password:
					del Players[userid]['pending character']
					Players[userid]['character'] = pending
					Steamids[steamid]['character'] = pending
					if not Characters[pending].has_key('Presence'):
						Characters[pending]['Presence'] = 1
					es.tell(userid, '#multi', '#lightgreen%s #defaultLoaded'%pending)
				else:
					es.tell(userid, '#lightgreen', 'You have entered an incorrect password...')
					es.escinputbox(10, userid, '-{ World of Darkness Load Character }-', 'Enter the Password:', 'wod passwordenter')
	elif arg1 == 'stealth':
		if Players[userid].has_key('character'):
			charactername = Players[userid]['character']
			if Characters[charactername].has_key('Stealth'):
				if Players[userid].has_key('stealth on'):
					on_off = Players[userid]['stealth on']
					if on_off == 0:
						allow = Players[userid]['allow stealth']
						if allow == 0:
							pen = Players[userid]['pen']
							Players[userid]['stealth on'] = 1
							stealth = Characters[charactername]['Stealth'] - pen
							dex = Characters[charactername]['Dexterity'] - pen
							speed(userid, -.2)
							color = 255 - (((dex*dex)*2)+((stealth*stealth)*2)+140)
							es.server.cmd('est_setplayercolor %s 255 255 255 %i 1'%(userid, color))
							es.tell(userid, '#lightgreen', 'You are now stealthed, enjoy being harder to see :)')
					elif on_off == 1:
						speed(userid, .2)
						Players[userid]['stealth on'] = 0
						es.server.cmd('est_setplayercolor %s 255 255 255 255 1'%userid)
						es.tell(userid, '#lightgreen', 'You have come out of your stealth.')
	elif arg1 == 'wolf':
		player = playerlib.getPlayer(userid)
		isdead = player.get('isdead')
		if isdead == 0:
			if Players[userid].has_key('wolf used'):
				used = Players[userid]['wolf used']
				form = Players[userid]['wolf form']
				if used == 0:
					Players[userid]['wolf used'] = 1
					Players[userid]['wolf form'] = 1
					health(userid, 200, 1)
					speed(userid, .6)
					Players[userid]['secondary'] = player.get('secondary')
					Players[userid]['sec clip'] = player.get('clip', 'secondary')
					Players[userid]['sec ammo'] = player.get('ammo', 'secondary')
					Players[userid]['primary'] = player.get('primary')
					Players[userid]['p clip'] = player.get('clip', 'primary')
					Players[userid]['p ammo'] = player.get('ammo', 'primary')
					es.server.cmd('est_removeweapon %s 1;est_removeweapon %s 2'%(userid, userid))
					gamethread.delayedname(10, 'unwolf%s'%userid, unwolf, (userid, roundnumber))
					es.tell(userid, '#lightgreen', 'You are now in wolf form! You are quick and deadly!')
				else:
					if form == 1:
						unwolf(userid, roundnumber)
						gamethread.cancelDelayed('unwolf%s'%userid)
					else:
						es.tell(userid, '#lightgreen', 'You have already used you wolf form this round!')
	elif arg1 == 'sprint':
		if Players[userid].has_key('character'):
			charactername = Players[userid]['character']
			if Players[userid].has_key('sprint status'):
				status = Players[userid]['sprint status']
				if status == 0:
					Players[userid]['sprint status'] = 1
					if Characters[charactername].has_key('Athletics'):
						pen = Players[userid]['pen']
						boost = ((Characters[charactername]['Athletics'] - pen + 1)*(Characters[charactername]['Athletics'] - pen + 1))*.01
						speed(userid, boost)
						es.tell(userid, '#lightgreen', 'You move quicker for the next 8 seconds.')
						gamethread.delayed(8, athdown, (userid, boost, roundnumber))
	elif arg1 == 'dread':
		if Players[userid].has_key('dread uses'):
			if not playerlib.getPlayer(userid).get('isdead'):
				if Players[userid]['dread uses'] == 0:
					Players[userid]['dread uses'] = 1
					es.ServerVar('player').set(0)
					es.server.cmd('est_near player #a 720 %s "if (server_var(player) != %s) then es_xdoblock worldofdarkness/dread_run"'%(userid, userid))
				else:
					es.tell(userid, '#lightgreen', 'You have always used your dread for this round!')
	elif arg1 == 'stare':
		if Players[userid].has_key('stare uses'):
			if not playerlib.getPlayer(userid).get('isdead'):
				if Players[userid]['stare uses'] == 0:
					es.ServerVar('point').set(0)
					es.server.cmd('est_getviewplayer %s point'%userid)
					point = int(es.ServerVar('point'))
					if point != 0:
						es.msg('point != 0')
						Players[userid]['stare uses'] = 1
						stun(point, 8)
						es.tell(point, '#lightgreen', 'You have been petrified for the next 8 seconds.')
				else:
					es.tell(userid, '#lightgreen', 'You have always used your stare for this round!')
	elif arg1 == 'shatter':
		if Players[userid].has_key('shatter uses'):
			if not playerlib.getPlayer(userid).get('isdead'):
				if Players[userid]['shatter uses'] == 0:
					es.ServerVar('point').set(0)
					es.server.cmd('est_getviewplayer %s point'%userid)
					point = str(es.ServerVar('point'))
					if point != '0':
						Players[userid]['shatter uses'] = 1
						es.server.cmd('est_drug %s 8'%point)
						Players[point]['pen'] = Players[point]['pen'] - 1
						gamethread.delayed(1, randomview, point)
						gamethread.delayed(3, randomview, point)
						gamethread.delayed(5, randomview, point)
						es.tell(point, '#lightgreen', 'Your mind has been shattered...')
				else:
					es.tell(userid, '#lightgreen', 'You have always used your shatter for this round!')
	elif arg1 == 'whirlwind':
		if Players[userid].has_key('whirlwind uses'):
			if not playerlib.getPlayer(userid).get('isdead'):
				if Players[userid]['whirlwind uses'] == 0:
					es.ServerVar('point').set(0)
					es.server.cmd('est_getviewplayer %s point'%userid)
					point = int(es.ServerVar('point'))
					if point != 0:
						Players[userid]['whirlwind uses'] = 1
						playerlib.getPlayer(point).set('push', [0, 800, 1])
						gamethread.delayed(8, whirlwindreset, (userid, roundnumber))
				else:
					es.tell(userid, '#lightgreen', 'Your whirlwind power is still recharging.')
	elif arg1 == 'flood':
		if Players[userid].has_key('flood uses'):
			if not playerlib.getPlayer(userid).get('isdead'):
				if Players[userid]['flood uses'] == 0:
					Players[userid]['flood uses'] = 1
					flood_loop(userid, roundnumber)
					es.msg('#lightgreen', 'A werewolf has begun calling a flood! Players are slowly going to drown!')
	elif arg1 == 'heal':
		if Players[userid].has_key('character'):
			charactername = Players[userid]['character']
			if Characters[charactername].has_key('Psyic Healer'):
				if not playerlib.getPlayer(userid).get('isdead'):
					es.ServerVar('point').set(0)
					es.server.cmd('est_getviewplayer %s point'%userid)
					point = str(es.ServerVar('point'))
					if point != '0' and point != userid:
						dealdamage(userid, userid, 15, 'myself', 'myself')
						gamethread.delayed(2, heal, (point, 10))
						gamethread.delayed(4, heal, (point, 10))
						gamethread.delayed(6, heal, (point, 10))
						gamethread.delayed(8, heal, (point, 10))
						gamethread.delayed(10, heal, (point, 10))
	elif arg1 == 'swap':
		if Players[userid].has_key('character'):
			charactername = Players[userid]['character']
			if Characters[charactername].has_key('Playful'):
				if not playerlib.getPlayer(userid).get('isdead'):
					if Players[userid].has_key('swap delay'):
						if not Players[userid]['swap delay']:
							es.ServerVar('point').set(0)
							es.server.cmd('est_getviewplayer %s point'%userid)
							point = int(es.ServerVar('point'))
							if point:
								if Players[str(point)].has_key('character'):
									if not Characters[Players[str(point)]['character']].has_key('Mediumist'):
										tupple1 = es.getplayerlocation(point)
										tupple2 = es.getplayerlocation(userid)
										playerlib.getPlayer(userid).set('location', tupple1)
										playerlib.getPlayer(point).set('location', tupple2)
										Players[userid]['swap delay'] = 1
										gamethread.delayed(8, default, (userid, 'swap'))
									else:
										es.tell(userid, '#lightgreen', 'There is some type of force blocking you from swapping with that player.')
								else:
									tupple1 = es.getplayerlocation(point)
									tupple2 = es.getplayerlocation(userid)
									playerlib.getPlayer(userid).set('location', tupple1)
									playerlib.getPlayer(point).set('location', tupple2)
									Players[userid]['swap delay'] = 1
									gamethread.delayed(8, default, (userid, 'swap'))
						else:
							es.tell(userid, '#lightgreen', 'Your swap is still recharging!')
	elif arg1 == 'teleport':
		if Players[userid].has_key('character'):
			charactername = Players[userid]['character']
			if Characters[charactername].has_key('Playful'):
				if Characters[charactername]['Playful'] >= 2:
					if not playerlib.getPlayer(userid).get('isdead'):
						if Players[userid].has_key('tele delay'):
							if not Players[userid]['tele delay']:
								playermenu = popuplib.easymenu('playermenu', '_popup_choice', playerselect)
								playermenu.settitle('Choose a player to appear next to:')
								for id in playerlib.getUseridList('#all'):
									if Players[str(id)].has_key('character'):
										if not Characters[Players[str(id)]['character']].has_key('Mediumist'):
											playermenu.addoption((id, 'teleport'), es.getplayername(id))
									else:
										playermenu.addoption((id, 'teleport'), es.getplayername(id))
								playermenu.send(userid)
							else:
								es.tell(userid, '#lightgreen', 'Your teleport is still recharging!')
	#elif arg1 == 'cheatxp':
	#	xp(userid, int(es.getargv(2)))
	elif arg1 == 'smite':
		if Players[userid].has_key('character'):
			charactername = Players[userid]['character']
			if Characters[charactername].has_key('Mediumist'):
				if Characters[charactername]['Mediumist'] >= 2:
					if not playerlib.getPlayer(userid).get('isdead'):
						if Players[userid].has_key('smite delay'):
							if not Players[userid]['smite delay']:
								Players[userid]['smite delay'] = 1
								es.ServerVar('player').set(0)
								es.server.queuecmd('est_near player #u 360 %s "es est_burn server_var(player) 8"'%userid)
								gamethread.delayed(10, default, (userid, 'smite'))
							else:
								es.tell(userid, '#lightgreen', 'Your smite is still recharging.')
	elif arg1 == 'salt':
		if Players[userid].has_key('character'):
			charactername = Players[userid]['character']
			if Characters[charactername].has_key('Mediumist'):
				if Characters[charactername]['Mediumist'] >= 3:
					if not playerlib.getPlayer(userid).get('isdead'):
						if Players[userid].has_key('salt delay'):
							if not Players[userid]['salt delay']:
								Players[userid]['salt delay'] = 1
								es.ServerVar('player').set(0)
								es.server.queuecmd('est_near player #u 360 %s "es est_stun server_var(player) 1;es_delayed 5 est_stun server_var(player) 0"'%userid)
								gamethread.delayed(8, default, (userid, 'salt'))
							else:
								es.tell(userid, '#lightgreen', 'Your salt stun is still recharging.')
	elif arg1 == 'bane':
		if Players[userid].has_key('character'):
			charactername = Players[userid]['character']
			if Characters[charactername].has_key('Mediumist'):
				if Characters[charactername]['Mediumist'] >= 4:
					if not playerlib.getPlayer(userid).get('isdead'):
						if Players[userid].has_key('bane delay'):
							if not Players[userid]['bane delay']:
								Players[userid]['bane delay'] = 1
								es.ServerVar('player').set(0)
								es.server.queuecmd('est_near player #u 360 %s "es playerset push server_var(player) 500 500 0"'%userid)
								gamethread.delayed(8, default, (userid, 'bane'))
							else:
								es.tell(userid, '#lightgreen', 'Your bane is still recharging.')
	elif arg1 == 'banish':
		if Players[userid].has_key('character'):
			charactername = Players[userid]['character']
			if Characters[charactername].has_key('Mediumist'):
				if Characters[charactername]['Mediumist'] >= 4:
					if not playerlib.getPlayer(userid).get('isdead'):
						if Players[userid].has_key('banish delay'):
							if not Players[userid]['banish delay']:
								Players[userid]['banish delay'] = 1
								es.ServerVar('player').set(0)
								es.server.queuecmd('est_near player #u 360 %s "es est_team server_var(player) 1;es_tell server_var(player) #lightgreen You have been banished for the remainder of the round.;es_tell %s #multi #defaultYou have banished a #greenspirit#default."'%(userid, userid))
								gamethread.delayed(15, default, (userid, 'banish'))
							else:
								es.tell(userid, '#lightgreen', 'Your banish is still recharging.')
	else:
		es.tell(userid, '#lightgreen', 'Sorry that is not a valid WoD Mod Command! Please use "WoD Help" to see a list of commands.')
def statmenu(userid):
	if Players.has_key(userid):
		if Players[userid].has_key('character'):
			charactername = Players[userid]['character']
			template = Characters[charactername]['template']
			xp = Characters[charactername]['xp']
			totalxp = Characters[charactername]['totalxp']
			statsmenu = popuplib.create('statsmenu')
			statsmenu.addline('Character Information:')
			statsmenu.addline('Name: %s'%charactername)
			statsmenu.addline('Template: %s'%template)
			statsmenu.addline('Unspent Experience: %f'%xp)
			statsmenu.addline('Total Experience: %f'%totalxp)
			statsmenu.addline('-> 5. Powers')
			statsmenu.addline('-> 6. Merrits')
			statsmenu.addline('-> 7. Skills')
			statsmenu.addline('-> 8. Attributes')
			statsmenu.addline('-> 9. Back to Main Menu')
			statsmenu.addline('0. - Exit')
			statsmenu.submenu(9, 'mainmenu')
			statsmenu.menuselect = statsblock
			statsmenu.send(userid)
		else:
			es.tell(userid, '#lightgreen', 'You do not have a character created/loaded yet!')
			mainmenu.send(userid)
def whirlwindreset(userid, roundcount):
	if roundcount == roundnumber:
		global Players
		Players[userid]['whirlwind uses'] = 0
		es.tell(userid, '#lightgreen', 'Your whirlwind power is ready to be used again.')
def stun(userid, time):
	es.server.cmd('est_freeze %s 1'%userid)
	gamethread.delayed(time, unstun, userid)
def unstun(userid):
	es.server.cmd('est_freeze %s 0'%userid)
def randomview(userid):
	playerlib.getPlayer(userid).set('viewcoord', [random.randrange(-5000,5000), random.randrange(-5000,5000), random.randrange(-5000,5000)])
def dread_run():
	global Players
	userid = str(es.ServerVar('player'))
	if Players.has_key(userid):
		if Players[userid].has_key('pen'):
			Players[userid]['pen'] = Players[userid]['pen'] - 2
			es.tell(userid, '#green', 'You have been affected by dread... you are weaked for the next 10 seconds.')
			gamethread.delayed(10, undread, userid)
def undread(userid):
	global Players
	Players[userid]['pen'] = Players[userid]['pen'] + 2
def athdown(userid, amount, roundcount):
	global roundnumber
	if roundcount == roundnumber:
		es.tell(userid, '#lightgreen', 'Your sprint has ended and you are winded for a short time.')
		amount = (amount * -1) * 2
		speed(userid, amount)
		amount = (amount * -1) / 2
		gamethread.delayed(4, athup, (userid, amount, roundnumber))
def athup(userid, amount, roundcount):
	global roundnumber
	global Players
	if roundcount == roundnumber:
		es.tell(userid, '#lightgreen', 'You have catch you breath and are ready to run again.')
		speed(userid, amount)
		Players[userid]['sprint status'] = 0
def unwolf(userid, roundcount):
	global roundnumber
	if roundcount == roundnumber:
		global Players
		speed(userid, -.6)
		player = playerlib.getPlayer(userid)
		health = player.get('health') - 200
		if health <= 1024:
			player.set('health', 1025)
		else:
			player.set('health', health)
		Players[userid]['maxhealth'] = Players[userid]['maxhealth'] - 200
		Players[userid]['wolf form'] = 0
		primary = Players[userid]['primary']
		if primary != '0':
			es.server.cmd('es_xgive %s %s'%(userid, 'weapon_%s'%primary))
			pclip = Players[userid]['p clip']
			pammo = Players[userid]['p ammo']
			player.set('clip', ['primary', pclip])
			player.set('ammo', ['primary', pammo])
		secondary = Players[userid]['secondary']
		if secondary != '0':
			es.server.cmd('es_xgive %s %s'%(userid, 'weapon_%s'%secondary))
			secclip = Players[userid]['sec clip']
			secammo =  Players[userid]['sec ammo']
			player.set('clip', ['secondary', secclip])
			player.set('ammo', ['secondary', secammo])
		es.tell(userid, '#lightgreen', 'Your wolf form has ended for this round.')
def statsblock(userid, choice, popupid):
	global Players
	global Characters
	charactername = Players[str(userid)]['character']
	if choice >= 1 and choice <= 4:
		statmenu(userid)
	elif choice == 5:
		powermenu = popuplib.create('powermenu')
		powermenu.addline('Powers:')
		global giftslist
		for g in giftslist:
			if Characters[charactername].has_key(g):
				dots = Characters[charactername][g]
				if dots != 'single':
					powermenu.addline('%s(%s)'%(g, dots))
				else:
					powermenu.addline('%s'%g)
		global discplineslist
		for d in discplineslist:
			if Characters[charactername].has_key(d):
				dots = Characters[charactername][d]
				if dots != 'single':
					powermenu.addline('%s(%s)'%(d, dots))
				else:
					powermenu.addline('%s'%d)
		powermenu.addline('-> 9. Back')
		powermenu.addline('0. - Exit')
		powermenu.menuselect = resendstat
		powermenu.send(userid)
	elif choice == 6:
		merritmenu = popuplib.create('merritmenu')
		merritmenu.addline('Merrits:')
		global merritslist
		for merrit in merritslist:
			if Characters[charactername].has_key(merrit):
				dots = Characters[charactername][merrit]
				if dots != 'single':
					merritmenu.addline('%s(%s)'%(merrit, dots))
				else:
					merritmenu.addline('%s'%merrit)
		merritmenu.addline('-> 9. Back')
		merritmenu.addline('0. - Exit')
		merritmenu.menuselect = resendstat
		merritmenu.send(userid)
	elif choice == 7:
		skillmenu = popuplib.create('skillmenu')
		skillmenu.addline('Skills:')
		global skillslist
		for skill in skillslist:
			if Characters[charactername].has_key(skill):
				dots = Characters[charactername][skill]
				skillmenu.addline('%s(%i)'%(skill, dots))
		skillmenu.addline('-> 9. Back')
		skillmenu.addline('0. - Exit')
		skillmenu.menuselect = resendstat
		skillmenu.send(userid)
	elif choice == 8:
		atmenu = popuplib.create('atmenu')
		atmenu.addline('Attributes:')
		global attributeslist
		for at in attributeslist:
			dots = Characters[charactername][at]
			atmenu.addline('%s(%i)'%(at, dots))
		atmenu.addline('-> 9. Back')
		atmenu.addline('0. - Exit')
		atmenu.menuselect = resendstat
		atmenu.send(userid)
def resendstat(userid, choice, popupid):
	statmenu(str(userid))
def playerselect(userid, choice, popupid):
	global Players
	if choice[1] == 'teleport':
		if not Players[str(userid)]['tele delay']:
			Players[str(userid)]['tele delay'] = 1
			es.server.queuecmd('playerset moveto %s %s'%(userid, choice[0]))
			gamethread.delayed(14, default, (userid, 'tele'))
		else:
			es.tell(userid, '#lightgreen', 'You jerk... Do not stack the menus.')
def default(userid, var):
	global Players
	Players[str(userid)]['%s delay'%var] = 0
def damage_loop(userid, amount, delay, radius, roundstarted):
	if roundnumber == roundstarted:
		if es.exists('userid', userid):
			if not playerlib.getPlayer(userid).get('isdead'):
				es.ServerVar('amount').set(amount)
				es.ServerVar('attacker').set(userid)
				es.ServerVar('player').set(0)
				es.server.cmd('est_near player #a %i %s "es_xdoblock worldofdarkness/damage_run"'%(radius, userid))
				gamethread.delayed(delay, damage_loop, (userid, amount, delay, radius, roundstarted))
def damage_run():
	userid = str(es.ServerVar('player'))
	attacker = str(es.ServerVar('attacker'))
	amount = str(es.ServerVar('amount'))
	global Players
	global Characters
	if Players[str(userid)].has_key('character'):
		charactername = Players[str(userid)]['character']
		template = Characters[charactername]['template']
		if template != 'Vampire':
			dealdamage(userid, attacker, amount, 'null', 'void')
def spirit_loop(userid, amount, delay, radius, roundstarted):
	if roundnumber == roundstarted:
		if es.exists('userid', userid):
			if not playerlib.getPlayer(userid).get('isdead'):
				es.ServerVar('amount').set(amount)
				es.ServerVar('attacker').set(userid)
				es.ServerVar('player').set(0)
				es.server.cmd('est_near player #a %i %s "es_xdoblock worldofdarkness/sp_run"'%(radius, userid))
				gamethread.delayed(delay, spirit_loop, (userid, amount, delay, radius, roundstarted))
def sp_run():
	userid = str(es.ServerVar('player'))
	attacker = str(es.ServerVar('attacker'))
	amount = str(es.ServerVar('amount'))
	dealdamage(userid, attacker, amount, 'null', 'void')
def fear_loop(userid, roundstarted):
	if roundnumber == roundstarted:
		if es.exists('userid', userid):
			if not playerlib.getPlayer(userid).get('isdead'):
				es.server.cmd('est_near player #a 360 %s "es_xdoblock worldofdarkness/fear_run"'%userid)
				gamethread.delayed(4, fear_loop, (userid, roundstarted))
def fear_run():
	userid = str(es.ServerVar('player'))
	global Players
	global Characters
	if Players[userid].has_key('character'):
		charactername = Players[userid]['character']
		template = Characters[charactername]['template']
		if template != 'Vampire':
			es.server.cmd('est_shake %s 4 10 5'%userid)
def drug_loop(userid, roundstarted):
	if roundnumber == roundstarted:
		if es.exists('userid', userid):
			if not playerlib.getPlayer(userid).get('isdead'):
				es.server.cmd('est_near player #a 240 %s "es_xdoblock worldofdarkness/drug_run"'%userid)
				gamethread.delayed(4, drug_loop, (userid, roundstarted))
def drug_run():
	userid = str(es.ServerVar('player'))
	es.server.cmd('est_drug %s 4'%userid)
def pull_loop(userid, roundstarted):
	if roundnumber == roundstarted:
		if es.exists('userid', userid):
			if not playerlib.getPlayer(userid).get('isdead'):
				es.ServerVar('x').set(0)
				es.ServerVar('y').set(0)
				es.ServerVar('z').set(0)
				es.server.cmd('es_xgetplayerlocation x y z %s'%userid)
				es.server.cmd('est_near player #a 360 %s "es_xdoblock worldofdarkness/pull_run"'%userid)
				gamethread.delayed(4, pull_loop, (userid, roundstarted))
def pull_run():
	userid = str(es.ServerVar('player'))
	es.server.cmd('est_pushto %s %s %s %s 5'%(userid, str(es.ServerVar('x')), str(es.ServerVar('y')), str(es.ServerVar('z'))))
def regen(userid, amount, delay, roundstarted):
	global roundnumber
	global Players
	if roundnumber == roundstarted:
		if es.exists('userid', userid):
			heal(userid, amount)
			gamethread.delayed(delay, regen, (userid, amount, delay, roundstarted))
def arearegen(userid, amount, delay, radius, roundstarted):
	global roundnumber
	global Players
	if roundnumber == roundstarted:
		if es.exists('userid', userid):
			team = int(es.getplayerteam(userid))
			if team == 2:
				heal = '#t'
			if team == 3:
				heal = '#c'
			else:
				heal = '#a'
			es.ServerVar('player').set(0)
			es.server.cmd('est_near player %s %s %s "es heal server_var(player) %s"'%(heal, radius, userid, amount))
			gamethread.delayed(delay, arearegen, (userid, amount, delay, radius, roundstarted))
def healcommand():
	heal(str(es.getargv(1)), int(es.getargv(2)))
def heal(userid, amount):
	if es.exists('userid', userid):
		if Players[userid].has_key('maxhealth'):
			maxhealth = Players[userid]['maxhealth'] + 1024
			player = playerlib.getPlayer(userid)
			health = player.get('health') + amount
			if health <= maxhealth:
				player.set('health', health)
			else:
				player.set('health', maxhealth)
def speed(userid, amount):
	global Players
	spd = Players[str(userid)]['speed'] + amount
	Players[str(userid)]['speed'] = spd
	es.server.cmd('est_speed %s %f'%(userid, spd))
def gravity(userid, amount):
	global Players
	if Players[userid].has_key('gravity'):
		gravity = Players[userid]['gravity'] + amount
		Players[userid]['gravity'] = gravity
		es.server.cmd('est_setgravity %s %f'%(userid, gravity))
def cash(userid, amount):
	Player = playerlib.getPlayer(userid)
	Player.set('cash', Player.get('cash') + amount)
def stealthdown(userid):
	global Players
	Players[userid]['allow stealth'] = Players[userid]['allow stealth'] - 1
def health(userid, amount, m):
	player = playerlib.getPlayer(userid)
	life = player.get('health') + int(amount)
	player.set('health', life)
	if m == 1:
		global Players
		life = Players[str(userid)]['maxhealth'] + amount
		Players[str(userid)]['maxhealth'] = life
def bioselect(userid, choice, popupid):
	global Players
	Userkey = Players[str(userid)]
	biopoints = Userkey['bio points']
	if choice == 'Quick Healer' and biopoints >= 4:
		Userkey['bio quick'] = 1
		regen(str(userid), 1, 2, roundnumber)
		biopoints -= 4
	elif choice == 'Fleet of Foot' and biopoints >= 1:
		Userkey['bio fleet'] += 1
		speed(userid, .03)
		biopoints -= 1
	elif choice == 'Hysterical Strength' and biopoints >= 1:
		Userkey['bio str'] += 1
		speed(userid, .01)
		damage_loop(userid, userid, 1, 10, roundnumber)
		biopoints -= 1
	Userkey['bio points'] = biopoints
	if biopoints:
		biomenu = popuplib.easymenu('biomenu', '_popup_choice', bioselect)
		biomenu.settitle('Biokinesis Enhancement Menu:')
		biolist = []
		if Userkey['bio fleet'] <= 2:
			biolist.append('Fleet of Foot')
		if Userkey['bio str'] <= 4:
			biolist.append('Hysterical Strength')
		if not Userkey['bio quick'] and biopoints >= 4:
			biolist.append('Quick Healer')
		for item in biolist:
			biomenu.addoption(item, item)
		biomenu.send(userid)
def flood_loop(userid, roundcount):
	global roundnumber
	if roundcount == roundnumber:
		if es.exists('userid', userid):
			if not playerlib.getPlayer(userid).get('isdead'):
				for player in playerlib.getUseridList('#all'):
					if Players[str(player)].has_key('speed'):
						spd = Players[str(player)]['speed']
						if spd <= .1:
							dealdamage(player, userid, 4, 'null', 'void')
						else:
							speed(str(player), -.01)
						gravity(str(player), .01)
				gamethread.delayed(2, flood_loop, (userid, roundcount))
def dealdamage(target, attacker, amount, targetname, attackername):
	global Players
	global Characters
	#es.msg('#multi', '#lightgreen%s #defaultjust hit #lightgreen%s #defaultfor #green%i #defaultdamage.'%(attackername, targetname, amount))
	if es.exists('userid', target):
		victim = playerlib.getPlayer(target)
		victimhealth = victim.get('health') - int(amount)
		victim.set('health', victimhealth)
		if Players[str(target)].has_key('character'):
			charactername = Players[str(target)]['character']
			template = Characters[charactername]['template']
			xp = Characters[charactername]['xp']
			if template == 'Vampire':
				if Players[str(target)].has_key('torpor'):
					torpor = Players[str(target)]['torpor']
				else:
					torpor = 1
				#es.msg('#multi', "#lightgreen%s's #defaultTorpor Value #green== #lightgreen%i"%(targetname, torpor))
				if torpor == 0:
					if victimhealth <= 1024:
						Players[str(target)]['torpor'] = 1
						maxhealth = Players[str(target)]['maxhealth']
						Players[str(target)]['secondary'] = victim.get('secondary')
						Players[str(target)]['sec clip'] = victim.get('clip', 'secondary')
						Players[str(target)]['sec ammo'] = victim.get('ammo', 'secondary')
						es.server.cmd('est_dropweapon %s 1;est_removeweapon %s 2'%(str(target), str(target)))
						spawnloc = Players[str(target)]['spawn location']
						#es.setpos(target, spawnloc)
						es.server.cmd('es_xsetpos %s %i %i %i'%(str(target), spawnloc[0], spawnloc[1], spawnloc[2]))
						victim.set('health', maxhealth + 1024)
						es.server.cmd('est_freeze %s 1'%str(target))
						#victim.set('freeze', 1)
						es.server.cmd('usermsg fade %s 2 2 6000 255 0 0 255'%target)
						gamethread.delayedname(10, 'untorpor%s'%str(target),untorpor, (str(target)))
				elif torpor == 1:
					if victimhealth <= 1024:
						victim.set('health', 1)
						es.server.cmd('damage %s 1 32 %s'%(target, attacker))
			else:
				if victimhealth <= 1024:
					victim.set('health', 1)
					es.server.cmd('damage %s 1 32 %s'%(target, attacker))
		else:
			if victimhealth <= 1024:
				victim.set('health', 1)
				es.server.cmd('damage %s 1 32 %s'%(target, attacker))
def untorpor(userid):
	global Players
	if es.exists('userid', userid):
		Players[userid]['torpor'] = 0
		victim = playerlib.getPlayer(userid)
		es.server.cmd('est_freeze %s 0'%userid)
		#victim.set('freeze', 0)
		secondary = Players[userid]['secondary']
		if secondary != '0':
			es.server.cmd('es_xgive %s %s'%(userid, 'weapon_%s'%secondary))
			secclip = Players[userid]['sec clip']
			secammo =  Players[userid]['sec ammo']
			victim.set('clip', ['secondary', secclip])
			victim.set('ammo', ['secondary', secammo])
def damage_loop(userid, attacker, damage, delay, roundstarted):
	if roundstarted == roundnumber:
		dealdamage(userid, attacker, damage, 'null', 'void')
		gamethread.delayed(delay, damage_loop, (userid, attacker, damage, delay, roundstarted))
def spiritselect(userid, choice, popupid):
	userid = str(userid)
	global Characters
	Characters[Players[userid]['character']]['spirit type'] = choice
	es.server.queuecmd('est_spawn %s 1'%userid)
welcomemenu = None
xpmenu = None
infomenu = None
def menucreate():
	global mainmenu
	mainmenu = popuplib.create('mainmenu')
	mainmenu.addline('-{ World of Darkness Main Menu }-')
	mainmenu.addline('-> 1. Create Character')
	mainmenu.addline('-> 2. Load Character')
	mainmenu.addline('-> 3. Current Character Information')
	mainmenu.addline('-> 4. Spend Xp')
	mainmenu.addline('-> 5. Information Menu')
	mainmenu.addline('-> 6. Help Menu')
	mainmenu.addline('0. - Exit')
	mainmenu.submenu(4, 'xpmenu')
	mainmenu.submenu(5, 'infomenu')
	mainmenu.submenu(6, 'welcomemenu')
	mainmenu.menuselect = mainselect
	global welcomemenu
	welcomemenu = popuplib.create('welcomemenu')
	welcomemenu.addline('-{ Welcome to a World of Darkness }-')
	welcomemenu.addline('- From this point forward World of Darkness will be said as WoD -')
	welcomemenu.addline('- WoD Command List -')
	welcomemenu.addline('- WoD Menu - A main menu for the mod -')
	welcomemenu.addline('- WoD Create <Character Name> - Start creating your character -')
	welcomemenu.addline('- WoD Load <Character Name> - Load a preexisting character -')
	welcomemenu.addline('- WoD Stats - See what character your are playing -')
	welcomemenu.addline('- WoD Xp - Allows you to spend earned Experiance -')
	welcomemenu.addline('- WoD Info - Displays information about different WoD features -')
	welcomemenu.addline('- WoD Help - This Menu -')
	welcomemenu.addline('-> 9. To Main Menu')
	welcomemenu.addline('0. - Exit')
	welcomemenu.submenu(9, 'mainmenu')
	global xpmenu
	xpmenu = popuplib.create('xpmenu')
	xpmenu.addline('-{ World of Darkness Xp Spending Menu }-')
	xpmenu.addline('-> 1. Merrits')
	xpmenu.addline('-> 2. Skills')
	xpmenu.addline('-> 3. Super Natural Powers')
	xpmenu.addline('-> 4. Templates')
	xpmenu.addline('-> 5. Attributes')
	xpmenu.addline('-> 9. To Main Menu')
	xpmenu.addline('0. - Exit')
	xpmenu.submenu(9, 'mainmenu')
	xpmenu.menuselect = xpbuild
	global infomenu
	infomenu = popuplib.create('infomenu')
	infomenu.addline('-{ World of Darkness Information Menu }-')
	infomenu.addline('-> 1. Merrits')
	infomenu.addline('-> 2. Skills')
	infomenu.addline('-> 3. Super Natural Powers')
	infomenu.addline('-> 4. Templates')
	infomenu.addline('-> 5. Attributes')
	infomenu.addline('-> 9. To Main Menu')
	infomenu.addline('0. - Exit')
	infomenu.submenu(9, 'mainmenu')
	infomenu.submenu(1, 'merritinfo')
	infomenu.submenu(2, 'skillsinfo')
	infomenu.submenu(3, 'powersinfo')
	infomenu.submenu(4, 'templatesinfo')
	infomenu.submenu(5, 'attributesinfo')
	powersinfo = popuplib.create('powersinfo')
	powersinfo.addline('Select a Power:')
	powersinfo.addline('-> 1. Nightmare')
	powersinfo.addline('-> 2. Elemental Gifts')
	powersinfo.addline('-> 3. Playful Hauntings')
	powersinfo.addline('-> 9. Back')
	powersinfo.addline('0. Exit')
	powersinfo.submenu(1, 'nightmareinfo')
	powersinfo.submenu(2, 'elementalinfo')
	powersinfo.submenu(3, 'playfulinfo')
	powersinfo.submenu(9, 'infomenu')
	playfulinfo = popuplib.create('playfulinfo')
	playfulinfo.addline('Playful Hauntings:')
	playfulinfo.addline('Template Required: Spirit')
	playfulinfo.addline('Cost: Dot*5')
	playfulinfo.addline('Effects:')
	playfulinfo.addline(" Dot1: Use 'wod teleport' to move yourself next to the player of your choice.")
	playfulinfo.addline(" Dot2: Use 'wod swap' to trade places with the person you are looking at.")
	playfulinfo.addline(" Dot3: You disrupt the vision of those around you.")
	playfulinfo.addline(" Dot4: You pull players around you towards you.")
	playfulinfo.addline(" Dot5: The radius of your powers increases.")
	playfulinfo.addline('-> 9. Back')
	playfulinfo.addline('0. Exit')
	playfulinfo.submenu(9, 'powersinfo')
	elementalinfo = popuplib.create('elementalinfo')
	elementalinfo.addline('elemental Discipline:')
	elementalinfo.addline('Template Required: Werewolf')
	elementalinfo.addline('Cost: Dot*5')
	elementalinfo.addline('Effects:')
	elementalinfo.addline(' Dot1: Use the powers of water to blur the screen of your victims.')
	elementalinfo.addline(" Dot2: The power of earth pulls your victim towards the ground.")
	elementalinfo.addline(" Dot3: The power of fire burns your victims.")
	elementalinfo.addline(" Dot4: Say 'wod whirlwind' to toss the person you are looking at into the air.")
	elementalinfo.addline(" Dot5: Say 'wod flood' to begin flooding the map to slow and maybe kill all players.")
	elementalinfo.addline('-> 9. Back')
	elementalinfo.addline('0. Exit')
	elementalinfo.submenu(9, 'powersinfo')
	nightmareinfo = popuplib.create('nightmareinfo')
	nightmareinfo.addline('Nightmare Discipline:')
	nightmareinfo.addline('Template Required: Vampire')
	nightmareinfo.addline('Cost: Dot*5')
	nightmareinfo.addline('Effects:')
	nightmareinfo.addline(' Dot1: The screens of all non vampires near you shake with fear.')
	nightmareinfo.addline(" Dot2: Say 'wod dread' to reduce the skills of all around you.")
	nightmareinfo.addline(" Dot3: Say 'wod stare' to freeze the person you are looking at.")
	nightmareinfo.addline(" Dot4: Say 'wod shatter' to disrupt the person you are looking at.")
	nightmareinfo.addline(" Dot5: All non-vampires around you take damage every second.")
	nightmareinfo.addline('-> 9. Back')
	nightmareinfo.addline('0. Exit')
	nightmareinfo.submenu(9, 'powersinfo')
	attributesinfo = popuplib.create('attributesinfo')
	attributesinfo.addline('Select an Attribute:')
	attributesinfo.addline('-> 1. Cost')
	attributesinfo.addline('-> 2. Strength')
	attributesinfo.addline('-> 3. Dexterity')
	attributesinfo.addline('-> 4. Stamina')
	attributesinfo.addline('-> 5. Presence')
	attributesinfo.addline('-> 9. Back')
	attributesinfo.addline('0. Exit')
	attributesinfo.submenu(1, 'atgeneral')
	attributesinfo.submenu(2, 'strinfo')
	attributesinfo.submenu(3, 'dexinfo')
	attributesinfo.submenu(4, 'stminfo')
	attributesinfo.submenu(5, 'presenceinfo')
	attributesinfo.submenu(9, 'infomenu')
	presenceinfo = popuplib.create('presenceinfo')
	presenceinfo.addline('Presence Attribute:')
	presenceinfo.addline('Effects:')
	presenceinfo.addline(" - Increased Teammate's Health")
	presenceinfo.addline('  - Bonus Team Health = (Dots - 1)^2')
	presenceinfo.addline('-> 9. Back')
	presenceinfo.addline('0. Exit')
	presenceinfo.submenu(9, 'attributesinfo')
	stminfo = popuplib.create('stminfo')
	stminfo.addline('Stamina Attribute:')
	stminfo.addline('Effects:')
	stminfo.addline(' - Increased Health')
	stminfo.addline(' - Bonus Health = ((Dots-1)^2)*2')
	stminfo.addline('-> 9. Back')
	stminfo.addline('0. Exit')
	stminfo.submenu(9, 'attributesinfo')
	dexinfo = popuplib.create('dexinfo')
	dexinfo.addline('Dexterity Attribute:')
	dexinfo.addline('Effects:')
	dexinfo.addline(' - Increased Speed')
	dexinfo.addline('  - Percent Bonus = Dots')
	dexinfo.addline(' - Chance to take no damage from an attack')
	dexinfo.addline('  - Percent Chance = (Dots-Attacker Dex Dots)*5')
	dexinfo.addline('-> 9. Back')
	dexinfo.addline('0. Exit')
	dexinfo.submenu(9, 'attributesinfo')
	strinfo = popuplib.create('strinfo')
	strinfo.addline('Strength Attribute:')
	strinfo.addline('Effects:')
	strinfo.addline(' - Increased Speed')
	strinfo.addline('  - Percent Bonus = Dots')
	strinfo.addline(' - Increased Damage')
	strinfo.addline('  - Percent Bonus = (Dots-1)^2')
	strinfo.addline('-> 9. Back')
	strinfo.addline('0. Exit')
	strinfo.submenu(9, 'attributesinfo')
	atgeneral = popuplib.create('atgeneral')
	atgeneral.addline('Cost of Upgrading an Attribute:')
	atgeneral.addline(' Cost: Dot*5')
	atgeneral.addline('-> 9. Back')
	atgeneral.addline('0. Exit')
	atgeneral.submenu(9, 'attributesinfo')
	templatesinfo = popuplib.create('templatesinfo')
	templatesinfo.addline('Select a Template:')
	templatesinfo.addline('-> 1. Vampire')
	templatesinfo.addline('-> 2. Werewolf')
	templatesinfo.addline('-> 3. Psion')
	templatesinfo.addline('-> 4. Spirit')
	templatesinfo.addline('-> 9. Back')
	templatesinfo.addline('0. Exit')
	templatesinfo.submenu(1, 'vampireinfo')
	templatesinfo.submenu(2, 'werewolfinfo')
	templatesinfo.submenu(3, 'psioninfo')
	templatesinfo.submenu(4, 'spiritinfo')
	templatesinfo.submenu(9, 'infomenu')
	spiritinfo = popuplib.create('spiritinfo')
	spiritinfo.addline('Spirit Template:')
	spiritinfo.addline('Cost: 20')
	spiritinfo.addline('Types of Spirits:')
	spiritinfo.addline(' - Healing: Heal everyone around you every 5 seconds')
	spiritinfo.addline(' - Hateful: Hurt everyone around you every 5 seconds')
	spiritinfo.addline('-> 9. Back')
	spiritinfo.addline('0. Exit')
	spiritinfo.submenu(9, 'templatesinfo')
	psioninfo = popuplib.create('psioninfo')
	psioninfo.addline('Psion Template:')
	psioninfo.addline('Cost: 5')
	psioninfo.addline('Grants Access to Psion Merrits')
	psioninfo.addline('-> 9. Back')
	psioninfo.addline('0. Exit')
	psioninfo.submenu(9, 'templatesinfo')
	werewolfinfo = popuplib.create('werewolfinfo')
	werewolfinfo.addline('Werewolf Template:')
	werewolfinfo.addline('Cost: 15')
	werewolfinfo.addline('Powers:')
	werewolfinfo.addline(' Form of the Wolf:')
	werewolfinfo.addline(" - Once a round you may use 'wod wolf' in chat")
	werewolfinfo.addline(' - For a short time you gain increaed amounts of speed and health but may only use a knife')
	werewolfinfo.addline(' Regeneration:')
	werewolfinfo.addline(' - Heal 1 health every 2 seconds')
	werewolfinfo.addline('-> 9. Back')
	werewolfinfo.addline('0. Exit')
	werewolfinfo.submenu(9, 'templatesinfo')
	vampireinfo = popuplib.create('vampireinfo')
	vampireinfo.addline('Vampire Template:')
	vampireinfo.addline('Cost: 15')
	vampireinfo.addline('Powers:')
	vampireinfo.addline(' Torpor Sleep:')
	vampireinfo.addline(' - When you would die you instead go into a sleep for 10 seconds')
	vampireinfo.addline(' - If killed while sleeping you die')
	vampireinfo.addline('-> 9. Back')
	vampireinfo.addline('0. Exit')
	vampireinfo.submenu(9, 'templatesinfo')
	skillsinfo = popuplib.create('skillsinfo')
	skillsinfo.addline('Select a Skill:')
	skillsinfo.addline('-> 1. Cost')
	skillsinfo.addline('-> 2. Athletics')
	skillsinfo.addline('-> 3. Firearms')
	skillsinfo.addline('-> 4. Stealth')
	skillsinfo.addline('-> 5. Larceny')
	skillsinfo.addline('-> 6. Subterfuge')
	skillsinfo.addline('-> 7. Occult')
	skillsinfo.addline('-> 9. Back')
	skillsinfo.addline('0. Exit')
	skillsinfo.submenu(1, 'skillsgeneral')
	skillsinfo.submenu(2, 'athleticsinfo')
	skillsinfo.submenu(3, 'firearmsinfo')
	skillsinfo.submenu(4, 'stealthinfo')
	skillsinfo.submenu(5, 'larcenyinfo')
	skillsinfo.submenu(6, 'subterfugeinfo')
	skillsinfo.submenu(7, 'occultinfo')
	skillsinfo.submenu(9, 'infomenu')
	occultinfo = popuplib.create('occultinfo')
	occultinfo.addline('Occult Skill:')
	occultinfo.addline('Effects:')
	occultinfo.addline(' - Dot1: 10% increased damage to non-mortals')
	occultinfo.addline(' - Dot2: Your attacks have a chance to set vampires on fire')
	occultinfo.addline(' - Dot3: Your attacks slow werewolves')
	occultinfo.addline(' - Dot4: 20% to dodge attacks of non-mortals.')
	occultinfo.addline(' - Dot5: Your attacks have a chance to stun super natural creatures.')
	occultinfo.addline('-> 9. Back')
	occultinfo.addline('0. Exit')
	occultinfo.submenu(9, 'skillsinfo')
	subterfugeinfo = popuplib.create('subterfugeinfo')
	subterfugeinfo.addline('Subterfuge Skill:')
	subterfugeinfo.addline('Effects:')
	subterfugeinfo.addline(' Have a chance to appear as the opposing Team')
	subterfugeinfo.addline('Chance:')
	subterfugeinfo.addline(' - Dot1: 5%')
	subterfugeinfo.addline(' - Dot2: 15%')
	subterfugeinfo.addline(' - Dot3: 30%')
	subterfugeinfo.addline(' - Dot4: 50%')
	subterfugeinfo.addline(' - Dot5: 80%')
	subterfugeinfo.addline('-> 9. Back')
	subterfugeinfo.addline('0. Exit')
	subterfugeinfo.submenu(9, 'skillsinfo')
	larcenyinfo = popuplib.create('larcenyinfo')
	larcenyinfo.addline('Larceny Skill:')
	larcenyinfo.addline('Effects:')
	larcenyinfo.addline(" Steal Your Victim's Primary Weapon")
	larcenyinfo.addline('Chance:')
	larcenyinfo.addline(' - Dots^2')
	larcenyinfo.addline('-> 9. Back')
	larcenyinfo.addline('0. Exit')
	larcenyinfo.submenu(9, 'skillsinfo')
	stealthinfo = popuplib.create('stealthinfo')
	stealthinfo.addline('Stealth Skill:')
	stealthinfo.addline('Effects:')
	stealthinfo.addline(" Use 'wod stealth' in chat to become harder to see")
	stealthinfo.addline(' Gain Damage bonus = Dots*10%')
	stealthinfo.addline('Stealth Color Formula:')
	stealthinfo.addline(' ((Dex Dots)^2)*2 + ((Stealth Dots)^2)*2 + 140')
	stealthinfo.addline('-> 9. Back')
	stealthinfo.addline('0. Exit')
	stealthinfo.submenu(9, 'skillsinfo')
	skillsgeneral = popuplib.create('skillsgeneral')
	skillsgeneral.addline('Cost to Gain or Upgrade a Skill:')
	skillsgeneral.addline('Cost: Dot*3')
	skillsgeneral.addline('-> 9. Back')
	skillsgeneral.addline('0. Exit')
	skillsgeneral.submenu(9, 'skillsinfo')
	athleticsinfo = popuplib.create('athleticsinfo')
	athleticsinfo.addline('Athletics Skill:')
	athleticsinfo.addline('Effect: Lower Gravity')
	athleticsinfo.addline(" - Use 'wod sprint' in chat to move quicker for a short time.")
	athleticsinfo.addline('Sprint Info:')
	athleticsinfo.addline(' Percent Speed Bonus/Penalty = Dots^2')
	athleticsinfo.addline(' Move Quicker for 8 Seconds')
	athleticsinfo.addline(' Then lose speed equal to that gained for 4 seconds after wards.')
	athleticsinfo.addline('Lower Gravity Formula:')
	athleticsinfo.addline(' Percent Lower = (Dots^2)*2')
	athleticsinfo.addline('-> 9. Back')
	athleticsinfo.addline('0. Exit')
	athleticsinfo.submenu(9, 'skillsinfo')
	firearmsinfo = popuplib.create('firearmsinfo')
	firearmsinfo.addline('Firearms Skill:')
	firearmsinfo.addline('Effect Bonus Damage with all Guns')
	firearmsinfo.addline('Bonus Damage Formula:')
	firearmsinfo.addline(' Percent Bonus: ((Dots-1)^2)+1')
	firearmsinfo.addline('-> 9. Back')
	firearmsinfo.addline('0. Exit')
	firearmsinfo.submenu(9, 'skillsinfo')
	merritinfo = popuplib.create('merritinfo')
	merritinfo.addline('Select a Merrit:')
	merritinfo.addline('-> 1. Cost')
	merritinfo.addline('-> 2. Resources')
	merritinfo.addline('-> 3. Fighting Finesse')
	merritinfo.addline('-> 4. Quick Healer')
	merritinfo.addline('-> 5. Unseen Sense')
	merritinfo.addline('-> 6. Fleet of Foot')
	merritinfo.addline('-> 7. Danager Sense')
	merritinfo.addline('-> 8. Next')
	merritinfo.addline('-> 9. Back')
	merritinfo.addline('0. Exit')
	merritinfo.submenu(1, 'merritgeneral')
	merritinfo.submenu(2, 'resourceinfo')
	merritinfo.submenu(3, 'fightingfinesseinfo')
	merritinfo.submenu(4, 'quickhealerinfo')
	merritinfo.submenu(5, 'unseeninfo')
	merritinfo.submenu(6, 'fleetoffootinfo')
	merritinfo.submenu(7, 'danagerinfo')
	merritinfo.submenu(8, 'merrit2')
	merritinfo.submenu(9, 'infomenu')
	merrit2 = popuplib.create('merrit2')
	merrit2.addline('Select a Merrit:')
	merrit2.addline('-> 1. Biokinesis')
	merrit2.addline('-> 2. Psyic Healing')
	merrit2.addline('-> 3. Mediumist')
	merrit2.addline('-> 9. Back')
	merrit2.addline('0. Exit')
	merrit2.submenu(1, 'biokinesisinfo')
	merrit2.submenu(2, 'psyhealerinfo')
	merrit2.submenu(3, 'mediumistinfo')
	merrit2.submenu(9, 'merritinfo')
	mediumistinfo = popuplib.create('mediumistinfo')
	mediumistinfo.addline('Mediumist Merrit:')
	mediumistinfo.addline('Requirements: Psion')
	mediumistinfo.addline('Number of Dots: 5')
	mediumistinfo.addline('Effect: You can affect spirits in the world around you.')
	mediumistinfo.addline(" Dot1: Spirits are unable to teleport to you or swap places with you.")
	mediumistinfo.addline(" Dot2: Use 'wod smite' to smite nearby spirits with flame slowing their movement and dusrupting their vison.")
	mediumistinfo.addline(" Dot3: Use 'wod salt' to cause spirits near you find themselves un-able to move.")
	mediumistinfo.addline(" Dot4: Use 'wod bane' to throw all nearby spirits away from you.")
	mediumistinfo.addline(" Dot5: Use 'wod banish' to send all spirits near you back to the nether realms.")
	mediumistinfo.addline('-> 9. Back')
	mediumistinfo.addline('0. Exit')
	mediumistinfo.submenu(9, 'merritinfo')
	merritgeneral = popuplib.create('merritgeneral')
	merritgeneral.addline('Cost to Gain or Upgrade a Merrit:')
	merritgeneral.addline('Cost: Dot*2')
	merritgeneral.addline('-> 9. Back')
	merritgeneral.addline('0. Exit')
	merritgeneral.submenu(9, 'merritinfo')
	psyhealerinfo = popuplib.create('psyhealerinfo')
	psyhealerinfo.addline('Psyic Healer Merrit:')
	psyhealerinfo.addline('Requirements: Psion')
	psyhealerinfo.addline('Number of Dots: 5')
	psyhealerinfo.addline('Effects:')
	psyhealerinfo.addline(' - You heal slowly over time.')
	psyhealerinfo.addline(' - Use wod heal to trade health to heal the targeted player over 10 seconds.')
	psyhealerinfo.addline('-> 9. Back')
	psyhealerinfo.addline('0. Exit')
	psyhealerinfo.submenu(9, 'merritinfo')
	biokinesisinfo = popuplib.create('biokinesisinfo')
	biokinesisinfo.addline('Biokinesis Merrit:')
	biokinesisinfo.addline('Requirements: Psion')
	biokinesisinfo.addline('Number of Dots: 1-5')
	biokinesisinfo.addline('Effect: Gives the user different selected bonuses at the start of every round.')
	biokinesisinfo.addline('-> 9. Back')
	biokinesisinfo.addline('0. Exit')
	biokinesisinfo.submenu(9, 'merritinfo')
	fleetoffootinfo = popuplib.create('fleetoffootinfo')
	fleetoffootinfo.addline('Fleet of Foot Merrit:')
	fleetoffootinfo.addline('Requirements: None')
	fleetoffootinfo.addline('Number of Dots: 1-3')
	fleetoffootinfo.addline('Effect: +3% Speed Per Dot')
	fleetoffootinfo.addline('-> 9. Back')
	fleetoffootinfo.addline('0. Exit')
	fleetoffootinfo.submenu(9, 'merritinfo')
	danagerinfo = popuplib.create('danagerinfo')
	danagerinfo.addline('Danager Sense Merrit:')
	danagerinfo.addline('Requirements: None')
	danagerinfo.addline('Number of Dots: 2')
	danagerinfo.addline('Effect: +5% to your dodge attack chance')
	danagerinfo.addline('-> 9. Back')
	danagerinfo.submenu(9, 'merritinfo')
	danagerinfo.addline('0. Exit')
	unseeninfo = popuplib.create('unseeninfo')
	unseeninfo.addline('Unseen Sense Merrit:')
	unseeninfo.addline('Requirements: Mortal Template')
	unseeninfo.addline('Number of Dots: 3')
	unseeninfo.addline('Effect: Dodge the first attack from a supernatural Create each round')
	unseeninfo.addline('-> 9. Back')
	unseeninfo.addline('0. Exit')
	unseeninfo.submenu(9, 'merritinfo')
	resourceinfo = popuplib.create('resourceinfo')
	resourceinfo.addline('Resources Merrit:')
	resourceinfo.addline('Requirements: None')
	resourceinfo.addline('Number of Dots: 1-5')
	resourceinfo.addline('Effect: Bonus Cash Each Spawn')
	resourceinfo.addline('Bonus Cash Formula:')
	resourceinfo.addline(' (Dots^2)*500')
	resourceinfo.addline('-> 9. Back')
	resourceinfo.addline('0. Exit')
	resourceinfo.submenu(9, 'merritinfo')
	quickhealerinfo = popuplib.create('quickhealerinfo')
	quickhealerinfo.addline('Quick Healer Merrit:')
	quickhealerinfo.addline('Requirements: 4 Dots of Stamina')
	quickhealerinfo.addline('Number of Dots: 4')
	quickhealerinfo.addline('Effect: Recover 1 health every 2 seconds.')
	quickhealerinfo.addline('-> 9. Back')
	quickhealerinfo.addline('0. Exit')
	quickhealerinfo.submenu(9, 'merritinfo')
	fightingfinesseinfo = popuplib.create('fightingfinesseinfo')
	fightingfinesseinfo.addline('Fighting Finesse Merrit:')
	fightingfinesseinfo.addline('Requirements: 3 Dots of Dexterity')
	fightingfinesseinfo.addline('Number of Dots: 3')
	fightingfinesseinfo.addline('Effect: Use your Dexterity dots for bonus damage instead of strength.')
	fightingfinesseinfo.addline('-> 9. Back')
	fightingfinesseinfo.addline('0. Exit')
	fightingfinesseinfo.submenu(9, 'merritinfo')
	global spiritmenu
	spiritmenu = popuplib.easymenu('spiritmenu', '_popup_choice', spiritselect)
	typelist = ['Healing', 'Hateful']
	spiritmenu.settitle('What Type of Spirit are you:')
	for t in typelist:
		spiritmenu.addoption(t, t)
def except_hook(type, value, ttemplateback):
	error_list = tb_module.format_exception(type, value, ttemplateback)
	for message in error_list:
		es.dbgmsg(0, message.strip())
	f = open(es.getAddonPath(__name__[__name__.find('.') + 1:].replace('.', '/')) + '/errors.log', 'a')
	f.writelines([time.strftime('%x %X\n')] + error_list + ['\n'])
	f.close()
sys.excepthook = except_hook